#version 330

uniform samplerCube texUnit; 

in Data {
	vec3 normal;
	vec3 eye;
} DataIn;

out vec4 color1;
out vec4 color2;

void main() {

	vec3 n = normalize(DataIn.normal);
	vec3 e = normalize(DataIn.eye);
	vec3 t = reflect(e, n);
	vec3 reflect = texture(texUnit, t).rgb;

	float eta = 1.1;
	vec3 r = refract(e, n, eta);
	vec3 g = refract(e, n, eta+0.02);
	vec3 b = refract(e, n, eta+0.04);
	float k = 1.0 - eta * eta * (1.0 - dot(n, e) * dot(n, e));
	vec3 refract;

	refract = vec3(texture(texUnit, r).r, texture(texUnit, g).g, texture(texUnit, b).b);

	float fresnel = dot(-e, n);

	color1 = vec4(k * refract + (1-k) * reflect, 1.0) ;
	color2 = vec4(reflect, 1.0);
	color1 = vec4(refract, 1.0);
	
}