#version 330

layout (std140) uniform Matrices {
	mat4 m_pvm;
	mat4 m_model;
	mat3 m_normalModel;
};

uniform vec3 camPosWorld;

in vec4 position;
in vec3 normal;

out Data {
	vec3 normal;
	vec3 eye;
} DataOut;

void main () {
	
	DataOut.normal = normalize(m_normalModel * normal);

	vec3 pos = vec3(m_model * position);
	DataOut.eye = pos - camPosWorld;

	gl_Position = m_pvm * position;	
}